Bug 190190

Summary: Full AspectJ and AOP support
Product: java Reporter: Mikael_B
Component: UnsupportedAssignee: David Strupl <dstrupl>
Status: RESOLVED WONTFIX QA Contact: issues <issues.netbeans.org>
Priority: P2 CC:
Version: 7.2.1   
Target Milestone: TBD   
Hardware: All   
OS: All   
URL: http://www.eclipse.org/aspectj/
Whiteboard:
Issue Type: ENHANCEMENT Exception Report:

Description Mikael_B 2010-09-06 18:02:54 UTC
Netbeans is unsuitable for development technologies that make use of AspectJ or other AOP-technologies, like parts of the Spring Framework among others. While it is certainly possible to build also AspectJ files with Maven or Ant, code completion is not working and source files erroneously display compilation errors because AspectJ code in IDT-files for instance is not recognized by the IDE. Hints doesn't work either. This is all very unfortunate. 
With the excellent STS-Eclipse available Netbeans seem to not be able nor willing to offer a full alternative for Netbeans Users wishing to utilize AOP-technologies like AspectJ. Similar problems exist with JavaCC and similar.

Solutions:
To just leave this as unsupported as AspectJ have been treated for years do seem destructive. There exist a plugin in the "AspectJ (AJDE) for NetBeans" <http://plugins.netbeans.org/PluginPortal/faces/PluginDetailPage.jsp?pluginid=4015>
but this plugin seem only have partial support. For instance IDT-files doesn't seem to be supported.

I propose that the Netbeans Community starts a discussion on how to best implement full AspectJ support as soon as possible. After all AspectJ support is central in Spring Framework development, especially so with Spring Roo.
It's a very spotty experience to develop Roo-based applications using Netbeans even as Roo is an app that runs in a CLI, simply because code completion, compilation errors and hints does not work.
Comment 1 puce 2010-09-06 18:25:12 UTC
+1
Im currently also involved in a project which makes use of JavaCC and AspectJ - and am forced to use Eclipse because of the lack of support in NetBeans
Comment 2 David Strupl 2010-09-23 09:16:01 UTC
I am closing all reports in category Java/Unsupported as wontfix. These should
be dead issues --- if the reported cases are against some live part of the
NetBeans IDE please reopen and we can discuss to which category they belong.
Comment 3 Mikael_B 2010-09-23 11:51:29 UTC
What do you mean wontfix?

So what are we supposed to do to collect input from people that need a specific technologiy, that formerly only have been partially supported in a plugin?

The lack of Netbeans not being aware of the AspectJ code in ITD-files for code completion – makes it close to pointless trying to build tests and so on in Netbeans. 

So I suppose the category place this lack of support could be "code completion" or "awareness of other languages". Or "Spring Support Editor". I'm not sure what is the best category. Politically I feel Netbeans should be supporting Spring enough to be a viable alternative.

Building AspectJ code works fine via Maven. Writing it is another matter. 

Considering that aspect oriented programming is quite central in the Spring Framework (especially so when using Spring Roo), how can Netbeans afford to not support it?
Comment 4 tbarker9 2010-09-23 12:01:29 UTC
I do not like AspectJ and I do not like that Spring Roo is using it.  That said Spring Roo is a compelling product worth supporting which means AspectJ should be supported.
Comment 5 David Strupl 2010-09-23 12:34:39 UTC
By wontfix I mean that nobody from the current NetBeans team paid by Oracle is going to address this. It means considerable effort that we are not going to pay for. We are sorry but we cannot do everything. If you find someone who will implement it please reopen and assign to such person. Otherwise please leave the issue as resolved. Thanks for your understanding.
Comment 6 kanaparthikiran 2011-04-05 23:05:29 UTC
ok
Comment 7 bedge 2011-11-18 18:45:36 UTC
That's too bad. This completely eliminates netbeans as a spring dev tool.
Not surprising though if Oracle is trying to push new java EE over spring.
Comment 8 mandrews 2012-10-24 22:53:18 UTC
Horrible. AspectJ is a powerful tool and it is embraced by the community. If you want people to use your IDE as entry to your Server, db, cloud, etc, you might reconsider your attitude toward the community. I certainly hope AspectJ Support will be in future releases. Otherwise, as more of my code move that way - I will be moving away from Netbeans.
By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo